﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace VolgaIt
{

    class Obj
    {
        public int posI, posJ;
        public int count;

        public Obj(int posI, int posJ)
        {
            this.posI = posI;
            this.posJ = posJ;
            count = 0;
        }

        public Obj(int posI, int posJ, int count)
        {
            this.posI = posI;
            this.posJ = posJ;
            this.count = count;
        }
    }

    class Controller
    {
        public int[,] map; // 1 - свободно, 2 - стена, 3 - игрок, 4 - выход 
        public int sizeI, sizeJ;
        public int[,] visited;
        public Player player;

        List<Obj> objs;

        public int posPlayerI = 0, posPlayerJ = 0;

        public int minLength;
        public string minRoad;


        public void SearchRoad(string mapString)
        {
            try
            {
                objs = new List<Obj>();
                string[] parseMapString = mapString.Split('\n');
                sizeI = int.Parse(parseMapString[0].Split(' ')[0]);
                sizeJ = int.Parse(parseMapString[0].Split(' ')[1]);
                map = new int[sizeI + 10, sizeJ + 10];
                for (int i = 1; i <= sizeI; i++)
                {
                    string[] test = parseMapString[1].Split(' ');
                    for (int j = 0; j < sizeJ; j++)
                    {
                        int obj = 1;
                        string element = "";
                        if (j != sizeJ - 1)
                            element = parseMapString[i].Split(' ')[j];
                        else
                        {
                            element = parseMapString[i].Split(' ')[j].Split('\r')[0];
                        }
                        if (element[0] == '.')
                            obj = 1;
                        if (element[0] == 'X')
                            obj = 2;
                        if (element[0] == 'S')
                        {
                            obj = 3;
                            posPlayerI = i - 1;
                            posPlayerJ = j;
                        }
                        if (element[0] == 'E')
                            obj = 4;
                        if (element[0] == 'D')
                        {
                            string txtCount = "";
                            for (int k = 1; k < element.Length; i++)
                            {
                                txtCount += element[k];
                            }
                            int count = int.Parse(txtCount);
                            obj = 5;
                            objs.Add(new Obj(i, j, count));
                        }
                        if (element[0] == 'K')
                        {
                            string txtCount = "";
                            for (int k = 1; k < element.Length; i++)
                            {
                                txtCount += element[k];
                            }
                            int count = int.Parse(txtCount);
                            obj = 6;
                            objs.Add(new Obj(i, j, count));
                        }
                        if (element[0] == 'P') {
                            obj = 7;    
                        }
                        if (element[0] == 'F')
                        {
                            string txtCount = "";
                            for (int k = 1; k < element.Length; i++)
                            {
                                txtCount += element[k];
                            }
                            int count = int.Parse(txtCount);
                            obj = 8;
                            objs.Add(new Obj(i, j, count));
                        }
                        if (element[0] == 'H')
                        {
                            obj = 9;
                        }
                        map[i - 1, j] = obj;
                    }
                }

                minLength = sizeJ * sizeI;

                visited = new int[sizeI + 10, sizeJ + 10];

                for (int i = 0; i < sizeI + 10; i++)
                    for (int j = 0; j < sizeJ + 10; j++)
                        visited[i, j] = 0;
                player = new Player(posPlayerI, posPlayerJ);
                dfs(posPlayerI, posPlayerJ, 0, "");
                string movesTxt = minLength.ToString();
                movesTxt += Environment.NewLine;
                movesTxt += minRoad;

                File.WriteAllText("moves.txt", movesTxt);
            }
            catch
            {
                MessageBox.Show("Выберите другой файл");
            }
        }

        public void dfs(int posI, int posJ, int leng, string road)
        {
            if (!(posI >= 0 && posI < sizeI) || !(posJ >= 0 && posJ < sizeJ))
                return;

            if (map[posI, posJ] == 2)
                return;
            if (map[posI, posJ] == 4)
            {
                if (leng < minLength)
                {
                    minLength = leng;
                    minRoad = road;
                }
            }

            if (map[posI, posJ] == 7)
            {
                return;
            }

            if (map[posI, posJ] == 8) {
                if (visited[posI, posJ] == 2)
                {
                    visited[posI, posJ] = 1;
                    foreach (Obj obj in objs)
                        if (posI == obj.posI && posJ == obj.posJ)
                            player.HP -= obj.count;
                    if (player.HP <= 0)
                    {
                        player.lose();
                    }
                    dfs(posI, posJ + 1, leng + 1, road + "R");
                    dfs(posI + 1, posJ, leng + 1, road + "D");
                    dfs(posI, posJ - 1, leng + 1, road + "L");
                    dfs(posI - 1, posJ, leng + 1, road + "U");
                }
                else if (visited[posI, posJ] == 1)
                {
                    visited[posI, posJ] = 2;
                    return;
                }
            }

            if (map[posI, posJ] == 5)
            {
                if (visited[posI, posJ] == 0)
                {
                    foreach (Obj obj in objs)
                        if (posI == obj.posI && posJ == obj.posJ)
                        {
                            bool kostil = false;
                            foreach (int key in player.keys)
                                if (key == obj.count)
                                    kostil = true;
                            if (kostil == false)
                                return;
                        }
                }
                else
                {
                    foreach (Obj obj in objs)
                        if (posI == obj.posI && posJ == obj.posJ)
                        {
                            bool kostil = false;
                            foreach (int key in player.keys)
                                if (key == obj.count)
                                    kostil = true;
                            if (kostil == false)
                                return;
                            else
                            {
                                dfs(posI, posJ + 1, leng + 1, road + "R");
                                dfs(posI + 1, posJ, leng + 1, road + "D");
                                dfs(posI, posJ - 1, leng + 1, road + "L");
                                dfs(posI - 1, posJ, leng + 1, road + "U");
                            }
                        }
                }
            }

            if (map[posI, posJ] == 9)
            {
                player.HP = 100;
            }


            if (map[posI, posJ] == 6)
            {
                foreach (Obj obj in objs)
                    if (posI == obj.posI && posJ == obj.posJ)
                        player.HP -= obj.count;
            }
            if (visited[posI, posJ] == 0)
            {
                visited[posI, posJ] = 1;
                dfs(posI, posJ + 1, leng + 1, road + "R");
                dfs(posI + 1, posJ, leng + 1, road + "D");
                dfs(posI, posJ - 1, leng + 1, road + "L");
                dfs(posI - 1, posJ, leng + 1, road + "U");
            }
            return;
        }

        public void Moove(char direction)
        {
            if (direction == 'R')
            {
                map[player.posI, player.posJ] = 1;
                player.posJ++;
                map[player.posI, player.posJ] = 3;
            }
            if (direction == 'L')
            {
                map[player.posI, player.posJ] = 1;
                player.posJ--;
                map[player.posI, player.posJ] = 3;
            }
            if (direction == 'D')
            {
                map[player.posI, player.posJ] = 1;
                player.posI++;
                map[player.posI, player.posJ] = 3;
            }
            if (direction == 'U')
            {
                map[player.posI, player.posJ] = 1;
                player.posI--;
                map[player.posI, player.posJ] = 3;
            }
        }

        
    }
}
