﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Win32;

namespace VolgaIt
{
	/// <summary>
	/// Логика взаимодействия для MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
        Controller controller;
        System.Windows.Threading.DispatcherTimer timer;
        string mapString;
        int step = 0;
        public MainWindow()
		{
            InitializeComponent();
            controller = new Controller();
            this.ResizeMode = ResizeMode.NoResize;

        }

        private void BrowserFile_Click(object sender, RoutedEventArgs e)
        {
            step = 0;
            if (timer != null)
                timer.Stop();
            OpenFileDialog fileDialog = new OpenFileDialog();
            fileDialog.Filter = "txt files (*.txt)|*.txt";
            fileDialog.ShowDialog();
            string path = fileDialog.FileName;
            try
            {
                mapString = File.ReadAllText(path);
                controller.SearchRoad(mapString);
                DrawField();
            }
            catch { };

        }

        public void DrawField()
        {
            
            for (int i = 0; i < controller.sizeI; i++)
            {
                for (int  j = 0; j < controller.sizeJ; j++)
                {
                    int sizeRect = 400 / controller.sizeI;
                    Rectangle rect = new Rectangle();
                    rect.Width = sizeRect;
                    rect.Height = sizeRect;
                    Color color = new Color();
                    if (controller.map[i, j] == 2)
                    {
                        color = Colors.Black;
                    }
                    if (controller.map[i, j] == 1)
                    {
                        color = Colors.Green;
                    }
                    if (controller.map[i, j] == 3)
                    {
                        color = Colors.Red;
                    }
                    if (controller.map[i, j] == 4)
                    {
                        color = Colors.Pink;
                    }
                    rect.Fill = new SolidColorBrush(color);
                    canvas.Children.Add(rect);
                    Canvas.SetLeft(rect, sizeRect * j);
                    Canvas.SetTop(rect, sizeRect * i);
                }
            }
        }

        private void Run_Click(object sender, RoutedEventArgs e)
        {
                    timer = new System.Windows.Threading.DispatcherTimer();
                    timer.Tick += new EventHandler(Update);
                    timer.Interval = new TimeSpan(5000000);
                    timer.Start();
        }

        private void Update(object sender, EventArgs e)
        {
            if (step < controller.minRoad.Length)
            {
                controller.Moove(controller.minRoad[step]);
                DrawField();
                step++;
            }
            else
            {
                controller.SearchRoad(mapString);
                timer.Stop();
                WinUI winUI = new WinUI(step);
                winUI.Show();
                step = 0;
            }
        }
    }
}
